(function(mui, window, document, undefined) {
	mui.init();
	var get = function(id) {
		return document.getElementById(id);
	};
	var qsa = function(sel) {
		return [].slice.call(document.querySelectorAll(sel));
	};
	var ui = {
		question: get('question'),
		contact: get('contact'),
		imageList: get('image-list'),
		submit: get('submit')
	};
	ui.clearForm = function() {
		ui.question.value = '';
		ui.contact.value = '';
		ui.imageList.innerHTML = '';
		ui.newPlaceholder();
	};
	ui.getFileInputArray = function() {
		return [].slice.call(ui.imageList.querySelectorAll('input[type="file"]'));
	};
	ui.getFileInputIdArray = function() {
		var fileInputArray = ui.getFileInputArray();
		var idArray = [];
		fileInputArray.forEach(function(fileInput) {
			if(fileInput.value != '') {
				idArray.push(fileInput.getAttribute('id'));
			}
		});
		return idArray;
	};
	var imageIndexIdNum = 0;
	var imagefilesindex = 0;
	var imagecount = 0;
	var imagefiles = new Array();
	ui.newPlaceholder = function() {
		var fileInputArray = ui.getFileInputArray();
		if(fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		}
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.addEventListener('click', function(event) {
			event.stopPropagation();
			event.cancelBubble = true;
			setTimeout(function() {
				console.log("placeholder id is--->>" + (placeholder.getAttribute('id') - 1));
				var shuzuindexid = (placeholder.getAttribute('id') - 1);
				imagefiles[shuzuindexid] = ''; //将图片数组指定的值设为空，服务器判断为空就不转换
				ui.imageList.removeChild(placeholder);
				imagecount--;
			}, 0);
			return false;
		}, false);

		var fileInput = document.createElement('input');
		fileInput.setAttribute('type', 'file');
		fileInput.setAttribute('accept', 'image/*');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('change', function(event) {
			var file = fileInput.files[0];
			if(file) {
				var reader = new FileReader();
				reader.onload = function() {
					//处理 android 4.1 兼容问题
					var img = new Image();
					img.src = reader.result; // 传过来的图片路径在这里用。
					img.onload = function() {
						var that = this;
						console.log("wh = " + that.width + "," + that.height);
						//生成比例 
						var w = that.width,
							h = that.height,
							scale = w / h;
						w = 480 || w; //480  你想压缩到多大，改这里
						h = w / scale;
						console.log("wh = " + w + "," + h);
						//生成canvas
						var canvas = document.createElement('canvas');
						var ctx = canvas.getContext('2d');
						canvas.width = w;
						canvas.height = h;
						ctx.drawImage(that, 0, 0, w, h);
						//	var base6464 = canvas.toDataURL('image/jpeg', 1 || 0.2); //1最清晰，越低越模糊。
						var base6464 = canvas.toDataURL('image/jpeg', 0.2); //1最清晰，越低越模糊。
						var base64 = base6464.split(',')[1];
						imagefiles[imagefilesindex] = base64;
						imagefilesindex++;
						var dataUrl = 'data:image/png;base64,' + base64;
						placeholder.style.backgroundImage = 'url(' + dataUrl + ')';
						placeholder.setAttribute('id', imagefilesindex);
					}
				}
				reader.readAsDataURL(file);
				placeholder.classList.remove('space');
				ui.newPlaceholder();
			}
		}, false);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(fileInput);
		ui.imageList.appendChild(placeholder);
		imagecount++;
	};
	ui.newPlaceholder();

	ui.submit.addEventListener('tap', function(event) {
		if(ui.question.value == '' ||
			(ui.contact.value != '' &&
				ui.contact.value.search(/^(\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+)|([1-9]\d{4,9})$/) != 0)) {
			return mui.toast('信息填写不符合规范');
		} else {
			var wt = plus.nativeUI.showWaiting(); //显示等待页面
			var dataType = 'json';
			var stringdata = "";
			if(imagecount <= 1) {
				stringdata = null;
			} else {
				stringdata = "[";
				for(var i = 0; i < imagefilesindex; i++) {
					stringdata += "{" + "\"IMG_ID\"" + ":" + "\"" + "IMG" + i + "\"" + "," + "\"IMG\"" + ":" + "\"" + imagefiles[i] + "\"" + "},";
				};
				stringdata += "]";
			}

			//发送数据
			mui.ajax(webip + 'GetFeedBack', {
				data: {
					'F_Content': utf16toEntities(ui.question.value),
					'F_QQ_Email': ui.contact.value,
					'F_Open_ID': localStorage.useropenid,
					'data': stringdata,
					'appid': plus.runtime.appid,
					'imei': "no", //设备标识
					//'imei': plus.device.imei, //设备标识
					'p': mui.os.android ? 'a' : 'i', //平台类型，i表示iOS平台，a表示Android平台。
					//'md': plus.device.model, //设备型号
					'md': "no", //设备型号
					'app_version': plus.runtime.version,
					'plus_versin': plus.runtime.innerVersion, //基座版本号
					'os': mui.os.version,
					//'net': '' + plus.networkinfo.getCurrentType()
					'net': ''
				},
				dataType: 'json', //服务器返回json格式数据
				type: 'post', //HTTP请求类型
				timeout: 100000, //超时时间设置为10秒；
				success: function(data) {
					wt.close();
					mui.toast('提交成功~感谢您的意见，我们会尽快做出修改');
					ui.clearForm();
					mui.back();
				},
				error: function(xhr, type, errorThrown) {
					wt.close();
					mui.toast('提交失败~请检查网络');
					//异常处理；
					console.log(type);
				}
			});
		}
	}, false);
})(mui, window, document, undefined);